// GETTD.CPP - Implementation file for your Internet Server
//    An ISAPI Extension that retrieves the time and date.

#include "stdafx.h"
#include "GetTD.h"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CGetTDExtension, CHttpServer)
	// Get the system time and date.
	ON_PARSE_COMMAND(GetTD, CGetTDExtension, ITS_EMPTY)

	// Default parse map.
	ON_PARSE_COMMAND(Default, CGetTDExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CGetTDExtension)
END_PARSE_MAP(CGetTDExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CGetTDExtension object

CGetTDExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CGetTDExtension implementation

CGetTDExtension::CGetTDExtension()
{
}

CGetTDExtension::~CGetTDExtension()
{
}

BOOL CGetTDExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CGetTDExtension command handlers

void CGetTDExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	// Display an informational message on how to use this extension.
	*pCtxt << _T("<H2><CENTER>How to Use This ISAPI Extension</CENTER></H2>");
	*pCtxt << _T("Use the <STRONG><EM>GetTD</EM></STRONG> function to");
	*pCtxt << _T("retrieve the current Web server date and time.<P>");

	EndContent(pCtxt);
}

void CGetTDExtension::GetTD(CHttpServerContext* pCtxt)
{
	// Create a couple of local variables.
	CString	cDate;		// String representation of date.
	CString	cTime;		// String representation of time.
	CTime	oCurDate;	// Current date and time.

	// Get the current date and store it in a string.
	oCurDate = CTime::GetCurrentTime();
	cDate = oCurDate.Format("%A, %d %B %Y");
	cTime = oCurDate.Format("%I:%M %p");

	// Start an HTML page.
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	// Display the time and date.
	*pCtxt << _T("The system date is: ");
	*pCtxt << _T(cDate);
	*pCtxt << _T("<P>");
	*pCtxt << _T("The system time is: ");
	*pCtxt << _T(cTime);
	*pCtxt << _T("<P>");

	// End the HTML page.
	EndContent(pCtxt);
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CGetTDExtension, CHttpServer)
	//{{AFX_MSG_MAP(CGetTDExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
