// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Sngl_Doc.h"

#include "MainFrm.h"

// Include our help dialog.
#include "HelpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_BOLD, OnBold)
	ON_COMMAND(ID_ITALIC, OnItalic)
	ON_COMMAND(ID_STRIKETHROUGH, OnStrikethrough)
	ON_COMMAND(ID_UNDERLINE, OnUnderline)
	ON_COMMAND(ID_VIEW_FORMATTOOLBAR, OnViewFormattoolbar)
	ON_COMMAND(ID_CONTEXT_HELP, OnContextHelp)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBar2.Create(this) ||
		!m_wndToolBar2.LoadToolBar(IDR_FORMAT))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBar2.SetBarStyle(m_wndToolBar2.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar2.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndToolBar2);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnBold() 
{
	CRichEditView*	poView;		// Create a variable to hold our view.

	// Get the active view from the current window. Typecast it as a 
	// CRichEditView rather than a CView, the standard return value.
	poView = (CRichEditView*) GetActiveView();

	// Change the font settings as needed.
	poView->OnCharEffect(CFM_BOLD, CFE_BOLD);
}

void CMainFrame::OnItalic() 
{
	CRichEditView*	poView;		// Create a variable to hold our view.
	CHARFORMAT		cfFont;		// Create a structure for the font data.

	// Get the active view from the current window. Typecast it as a 
	// CRichEditView rather than a CView, the standard return value.
	poView = (CRichEditView*) GetActiveView();

	// Get the current font settings, then change them to Italic.
	cfFont = poView->GetCharFormatSelection();
	cfFont.dwMask |= CFM_ITALIC;
	cfFont.dwEffects |= CFE_ITALIC;

	// Change the font settings as needed.
	poView->SetCharFormat(cfFont);
}

void CMainFrame::OnStrikethrough() 
{
	CRichEditView*	poView;		// Create a variable to hold our view.

	// Get the active view from the current window. Typecast it as a 
	// CRichEditView rather than a CView, the standard return value.
	poView = (CRichEditView*) GetActiveView();

	// Change the font settings as needed.
	poView->OnCharEffect(CFM_STRIKEOUT, CFE_STRIKEOUT);
}

void CMainFrame::OnUnderline() 
{
	CRichEditView*	poView;		// Create a variable to hold our view.

	// Get the active view from the current window. Typecast it as a 
	// CRichEditView rather than a CView, the standard return value.
	poView = (CRichEditView*) GetActiveView();

	// Change the font settings as needed.
	poView->OnCharEffect(CFM_UNDERLINE, CFE_UNDERLINE);
}

void CMainFrame::OnViewFormattoolbar() 
{
	CMenu*	poMenu;		// Create a pointer to the current menu.

	poMenu = GetMenu();	// Get the menu.

	// Determine if the View | Format Toolbar option is checked. If it
	// is, then hide the format toolbar and uncheck the option. Otherwise,
	// display the toolbar and check the menu item.

	if (poMenu->GetMenuState(ID_VIEW_FORMATTOOLBAR, MF_CHECKED))
	{
		ShowControlBar(&m_wndToolBar2, FALSE, FALSE);	
		poMenu->CheckMenuItem(ID_VIEW_FORMATTOOLBAR, MF_UNCHECKED);
	}
	else
	{
		ShowControlBar(&m_wndToolBar2, TRUE, FALSE);
		poMenu->CheckMenuItem(ID_VIEW_FORMATTOOLBAR, MF_CHECKED);
	}
}

void CMainFrame::OnContextHelp() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnHelpContents() 
{
	CHelpDlg	oHelpDlg;	// Create a help dialog instance.

	// Display our help dialog.
	oHelpDlg.DoModal();
}
